# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from alfresco_core_api_client.api_client import ApiClient


class CategoriesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_category(self, category_id, category_body_create, **kwargs):  # noqa: E501
        """Create a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Creates a new category within the category **categoryId**.  The parameter categoryId can be set to the alias -root- to create a new top level category.  You must have admin rights to create a category.  It is possible to create more than one subcategory by posting a list of categories: ```JSON [   {     \"name\": \"test category 1\"   },   {     \"name\": \"test category 2\"   } ] ``` If you specify a list as input, then a paginated list rather than an entry is returned in the response body. For example:  ```JSON {   \"list\": {     \"pagination\": {       \"count\": 2,       \"hasMoreItems\": false,       \"totalItems\": 2,       \"skipCount\": 0,       \"maxItems\": 100     },     \"entries\": [       {         \"entry\": {           ...         }       },       {         \"entry\": {          ...         }       }     ]   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_category(category_id, category_body_create, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param CategoryBody category_body_create: The category details (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_category_with_http_info(category_id, category_body_create, **kwargs)  # noqa: E501
        else:
            (data) = self.create_category_with_http_info(category_id, category_body_create, **kwargs)  # noqa: E501
            return data

    def create_category_with_http_info(self, category_id, category_body_create, **kwargs):  # noqa: E501
        """Create a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Creates a new category within the category **categoryId**.  The parameter categoryId can be set to the alias -root- to create a new top level category.  You must have admin rights to create a category.  It is possible to create more than one subcategory by posting a list of categories: ```JSON [   {     \"name\": \"test category 1\"   },   {     \"name\": \"test category 2\"   } ] ``` If you specify a list as input, then a paginated list rather than an entry is returned in the response body. For example:  ```JSON {   \"list\": {     \"pagination\": {       \"count\": 2,       \"hasMoreItems\": false,       \"totalItems\": 2,       \"skipCount\": 0,       \"maxItems\": 100     },     \"entries\": [       {         \"entry\": {           ...         }       },       {         \"entry\": {          ...         }       }     ]   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_category_with_http_info(category_id, category_body_create, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param CategoryBody category_body_create: The category details (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['category_id', 'category_body_create', 'include', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_category" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `create_category`")  # noqa: E501
        # verify the required parameter 'category_body_create' is set
        if self.api_client.client_side_validation and ('category_body_create' not in params or
                                                       params['category_body_create'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_body_create` when calling `create_category`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'category_body_create' in params:
            body_params = params['category_body_create']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/categories/{categoryId}/subcategories', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_category_link_for_node(self, node_id, category_link_body_create, **kwargs):  # noqa: E501
        """Assign a node to a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Assign the node **nodeId** to a category. You specify the category ID in a JSON body like this:  ```JSON {   \"categoryId\": \"01234567-89ab-cdef-0123-456789abcdef\" } ```  **Note:** You can assign the node to more than one category by specifying a list of categories in the JSON body like this:  ```JSON [   {     \"categoryId\": \"01234567-89ab-cdef-0123-456789abcdef\"   },   {     \"categoryId\": \"89abcdef-0123-4567-89ab-cdef01234567\"   } ] ``` If you specify a list as input, then a paginated list rather than an entry is returned in the response body. For example:  ```JSON {   \"list\": {     \"pagination\": {       \"count\": 2,       \"hasMoreItems\": false,       \"totalItems\": 2,       \"skipCount\": 0,       \"maxItems\": 100     },     \"entries\": [       {         \"entry\": {           ...         }       },       {         \"entry\": {          ...         }       }     ]   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_category_link_for_node(node_id, category_link_body_create, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param CategoryLinkBody category_link_body_create: The new category link (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_category_link_for_node_with_http_info(node_id, category_link_body_create, **kwargs)  # noqa: E501
        else:
            (data) = self.create_category_link_for_node_with_http_info(node_id, category_link_body_create, **kwargs)  # noqa: E501
            return data

    def create_category_link_for_node_with_http_info(self, node_id, category_link_body_create, **kwargs):  # noqa: E501
        """Assign a node to a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Assign the node **nodeId** to a category. You specify the category ID in a JSON body like this:  ```JSON {   \"categoryId\": \"01234567-89ab-cdef-0123-456789abcdef\" } ```  **Note:** You can assign the node to more than one category by specifying a list of categories in the JSON body like this:  ```JSON [   {     \"categoryId\": \"01234567-89ab-cdef-0123-456789abcdef\"   },   {     \"categoryId\": \"89abcdef-0123-4567-89ab-cdef01234567\"   } ] ``` If you specify a list as input, then a paginated list rather than an entry is returned in the response body. For example:  ```JSON {   \"list\": {     \"pagination\": {       \"count\": 2,       \"hasMoreItems\": false,       \"totalItems\": 2,       \"skipCount\": 0,       \"maxItems\": 100     },     \"entries\": [       {         \"entry\": {           ...         }       },       {         \"entry\": {          ...         }       }     ]   } } ```   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_category_link_for_node_with_http_info(node_id, category_link_body_create, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param CategoryLinkBody category_link_body_create: The new category link (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'category_link_body_create', 'include', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_category_link_for_node" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `create_category_link_for_node`")  # noqa: E501
        # verify the required parameter 'category_link_body_create' is set
        if self.api_client.client_side_validation and ('category_link_body_create' not in params or
                                                       params['category_link_body_create'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_link_body_create` when calling `create_category_link_for_node`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'category_link_body_create' in params:
            body_params = params['category_link_body_create']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/category-links', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_category(self, category_id, **kwargs):  # noqa: E501
        """Delete a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Deletes the category with **categoryId**. This will cause everything to be removed from the category.  You must have admin rights to delete a category.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_category(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_category_with_http_info(category_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_category_with_http_info(category_id, **kwargs)  # noqa: E501
            return data

    def delete_category_with_http_info(self, category_id, **kwargs):  # noqa: E501
        """Delete a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Deletes the category with **categoryId**. This will cause everything to be removed from the category.  You must have admin rights to delete a category.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_category_with_http_info(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['category_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_category" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `delete_category`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/categories/{categoryId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_category_link_from_node(self, node_id, category_id, **kwargs):  # noqa: E501
        """Unassign a node from a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Removes the node **nodeId** from the category **categoryId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_category_link_from_node(node_id, category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str category_id: The identifier of a category. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_category_link_from_node_with_http_info(node_id, category_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_category_link_from_node_with_http_info(node_id, category_id, **kwargs)  # noqa: E501
            return data

    def delete_category_link_from_node_with_http_info(self, node_id, category_id, **kwargs):  # noqa: E501
        """Unassign a node from a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Removes the node **nodeId** from the category **categoryId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_category_link_from_node_with_http_info(node_id, category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param str category_id: The identifier of a category. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'category_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_category_link_from_node" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `delete_category_link_from_node`")  # noqa: E501
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `delete_category_link_from_node`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/category-links/{categoryId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_category(self, category_id, **kwargs):  # noqa: E501
        """Get a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Get a specific category with **categoryId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_category(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_category_with_http_info(category_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_category_with_http_info(category_id, **kwargs)  # noqa: E501
            return data

    def get_category_with_http_info(self, category_id, **kwargs):  # noqa: E501
        """Get a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Get a specific category with **categoryId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_category_with_http_info(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['category_id', 'include', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_category" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `get_category`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/categories/{categoryId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_categories_for_node(self, node_id, **kwargs):  # noqa: E501
        """List categories that a node is assigned to  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Gets a list of categories for node **nodeId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_categories_for_node(node_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param int skip_count: The number of entities that exist in the collection before those included in this list. If not supplied then the default value is 0. 
        :param int max_items: The maximum number of items to return in the list. If not supplied then the default value is 100. 
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryPaging
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_categories_for_node_with_http_info(node_id, **kwargs)  # noqa: E501
        else:
            (data) = self.list_categories_for_node_with_http_info(node_id, **kwargs)  # noqa: E501
            return data

    def list_categories_for_node_with_http_info(self, node_id, **kwargs):  # noqa: E501
        """List categories that a node is assigned to  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Gets a list of categories for node **nodeId**.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_categories_for_node_with_http_info(node_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str node_id: The identifier of a node. (required)
        :param int skip_count: The number of entities that exist in the collection before those included in this list. If not supplied then the default value is 0. 
        :param int max_items: The maximum number of items to return in the list. If not supplied then the default value is 100. 
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryPaging
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['node_id', 'skip_count', 'max_items', 'include', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_categories_for_node" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'node_id' is set
        if self.api_client.client_side_validation and ('node_id' not in params or
                                                       params['node_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `node_id` when calling `list_categories_for_node`")  # noqa: E501

        if self.api_client.client_side_validation and ('skip_count' in params and params['skip_count'] < 0):  # noqa: E501
            raise ValueError("Invalid value for parameter `skip_count` when calling `list_categories_for_node`, must be a value greater than or equal to `0`")  # noqa: E501
        if self.api_client.client_side_validation and ('max_items' in params and params['max_items'] < 1):  # noqa: E501
            raise ValueError("Invalid value for parameter `max_items` when calling `list_categories_for_node`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'node_id' in params:
            path_params['nodeId'] = params['node_id']  # noqa: E501

        query_params = []
        if 'skip_count' in params:
            query_params.append(('skipCount', params['skip_count']))  # noqa: E501
        if 'max_items' in params:
            query_params.append(('maxItems', params['max_items']))  # noqa: E501
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/nodes/{nodeId}/category-links', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryPaging',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_subcategories(self, category_id, **kwargs):  # noqa: E501
        """List categories  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Gets a list of subcategories within the category **categoryId**.  The parameter categoryId can be set to the alias -root- to obtain a list of top level categories.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_subcategories(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param int skip_count: The number of entities that exist in the collection before those included in this list. If not supplied then the default value is 0. 
        :param int max_items: The maximum number of items to return in the list. If not supplied then the default value is 100. 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryPaging
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_subcategories_with_http_info(category_id, **kwargs)  # noqa: E501
        else:
            (data) = self.list_subcategories_with_http_info(category_id, **kwargs)  # noqa: E501
            return data

    def list_subcategories_with_http_info(self, category_id, **kwargs):  # noqa: E501
        """List categories  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Gets a list of subcategories within the category **categoryId**.  The parameter categoryId can be set to the alias -root- to obtain a list of top level categories.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_subcategories_with_http_info(category_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param int skip_count: The number of entities that exist in the collection before those included in this list. If not supplied then the default value is 0. 
        :param int max_items: The maximum number of items to return in the list. If not supplied then the default value is 100. 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryPaging
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['category_id', 'include', 'skip_count', 'max_items', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_subcategories" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `list_subcategories`")  # noqa: E501

        if self.api_client.client_side_validation and ('skip_count' in params and params['skip_count'] < 0):  # noqa: E501
            raise ValueError("Invalid value for parameter `skip_count` when calling `list_subcategories`, must be a value greater than or equal to `0`")  # noqa: E501
        if self.api_client.client_side_validation and ('max_items' in params and params['max_items'] < 1):  # noqa: E501
            raise ValueError("Invalid value for parameter `max_items` when calling `list_subcategories`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'skip_count' in params:
            query_params.append(('skipCount', params['skip_count']))  # noqa: E501
        if 'max_items' in params:
            query_params.append(('maxItems', params['max_items']))  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/categories/{categoryId}/subcategories', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryPaging',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_category(self, category_id, category_body_update, **kwargs):  # noqa: E501
        """Update a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Updates the category **categoryId**.  You must have admin rights to update a category.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_category(category_id, category_body_update, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param CategoryBody category_body_update: The updated category (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_category_with_http_info(category_id, category_body_update, **kwargs)  # noqa: E501
        else:
            (data) = self.update_category_with_http_info(category_id, category_body_update, **kwargs)  # noqa: E501
            return data

    def update_category_with_http_info(self, category_id, category_body_update, **kwargs):  # noqa: E501
        """Update a category  # noqa: E501

        **Note:** this endpoint is available in Alfresco 7.4 and newer versions.  Updates the category **categoryId**.  You must have admin rights to update a category.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_category_with_http_info(category_id, category_body_update, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str category_id: The identifier of a category. (required)
        :param CategoryBody category_body_update: The updated category (required)
        :param list[str] include: Returns additional information about the category. The following optional fields can be requested: * count * path 
        :param list[str] fields: A list of field names.  You can use this parameter to restrict the fields returned within a response if, for example, you want to save on overall bandwidth.  The list applies to a returned individual entity or entries within a collection.  If the API method also supports the **include** parameter, then the fields specified in the **include** parameter are returned in addition to those specified in the **fields** parameter. 
        :return: CategoryEntry
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['category_id', 'category_body_update', 'include', 'fields']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_category" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'category_id' is set
        if self.api_client.client_side_validation and ('category_id' not in params or
                                                       params['category_id'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_id` when calling `update_category`")  # noqa: E501
        # verify the required parameter 'category_body_update' is set
        if self.api_client.client_side_validation and ('category_body_update' not in params or
                                                       params['category_body_update'] is None):  # noqa: E501
            raise ValueError("Missing the required parameter `category_body_update` when calling `update_category`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'category_id' in params:
            path_params['categoryId'] = params['category_id']  # noqa: E501

        query_params = []
        if 'include' in params:
            query_params.append(('include', params['include']))  # noqa: E501
            collection_formats['include'] = 'csv'  # noqa: E501
        if 'fields' in params:
            query_params.append(('fields', params['fields']))  # noqa: E501
            collection_formats['fields'] = 'csv'  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'category_body_update' in params:
            body_params = params['category_body_update']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/categories/{categoryId}', 'PUT',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='CategoryEntry',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
